// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S200_Partitions.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;

import java.util.ArrayList;


@SuppressWarnings("fallthrough")
class S200_Partitions extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int readPartitionState = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\5\0\2\1\1\0\1\5"+
    "\12\6\1\7\1\10\5\0\1\11\1\12\1\13\1\14"+
    "\1\15\1\14\1\16\1\17\1\20\1\14\1\21\1\22"+
    "\1\23\1\24\1\25\1\26\1\14\1\27\1\30\1\31"+
    "\2\14\1\32\1\33\2\14\1\34\1\0\1\35\1\0"+
    "\1\36\1\0\1\37\1\40\1\41\1\0\1\42\1\0"+
    "\1\43\1\44\1\45\1\0\1\46\1\47\1\50\1\51"+
    "\1\52\1\53\1\0\1\54\1\55\1\56\2\0\1\57"+
    "\1\60\267\0\2\45\115\0\1\55\u0182\0\1\1\20\0"+
    "\2\1\u0115\0\1\46\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\2\1\2\2\2\3\12\0\1\4\145\0\1\5"+
    "\41\0\1\5\30\0\1\6\1\7\1\10\42\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[217];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\61\0\142\0\223\0\304\0\223\0\365\0\223"+
    "\0\u0126\0\u0157\0\u0188\0\u01b9\0\u01ea\0\u021b\0\u024c\0\u027d"+
    "\0\u02ae\0\u02df\0\u0310\0\223\0\u0341\0\u0372\0\u03a3\0\u03d4"+
    "\0\u0405\0\u0436\0\u0467\0\u0498\0\u04c9\0\u04fa\0\u052b\0\u055c"+
    "\0\u058d\0\u05be\0\u05ef\0\u0620\0\u0651\0\u0682\0\u06b3\0\u06e4"+
    "\0\u0715\0\u0746\0\u0777\0\u07a8\0\u07d9\0\u080a\0\u083b\0\u086c"+
    "\0\u089d\0\u08ce\0\u08ff\0\u0930\0\u0961\0\u0992\0\u09c3\0\u09f4"+
    "\0\u0a25\0\u0a56\0\u0a87\0\u0ab8\0\u0ae9\0\u0b1a\0\u0b4b\0\u0b7c"+
    "\0\u0bad\0\u0bde\0\u0c0f\0\u0c40\0\u0c71\0\u0ca2\0\u0cd3\0\u0d04"+
    "\0\u0d35\0\u0d66\0\u0d97\0\u0dc8\0\u0df9\0\u0e2a\0\u0e5b\0\u0e8c"+
    "\0\u0ebd\0\u0eee\0\u0f1f\0\u0f50\0\u0f81\0\u0fb2\0\u0fe3\0\u1014"+
    "\0\u1045\0\u1076\0\u10a7\0\u10d8\0\u1109\0\u113a\0\u116b\0\u119c"+
    "\0\u11cd\0\u11fe\0\u122f\0\u1260\0\u1291\0\u12c2\0\u12f3\0\u1324"+
    "\0\u1355\0\u1386\0\u13b7\0\u13e8\0\u1419\0\u144a\0\u147b\0\u14ac"+
    "\0\u14dd\0\u150e\0\u153f\0\u1570\0\u15a1\0\u15d2\0\u1603\0\u1634"+
    "\0\u1665\0\223\0\u1696\0\u16c7\0\u16f8\0\u1729\0\u175a\0\u178b"+
    "\0\u17bc\0\u17ed\0\u181e\0\u184f\0\u1880\0\u18b1\0\u18e2\0\u1913"+
    "\0\u1944\0\u1975\0\u19a6\0\u19d7\0\u1a08\0\u1a39\0\u1a6a\0\u1a9b"+
    "\0\u1acc\0\u1afd\0\u1b2e\0\u1b5f\0\u1b90\0\u1bc1\0\u1bf2\0\u1c23"+
    "\0\u1c54\0\u1c85\0\u1cb6\0\u1ce7\0\u1ce7\0\u1d18\0\u1d49\0\u1d7a"+
    "\0\u1dab\0\u1ddc\0\u1e0d\0\u1e3e\0\u1e6f\0\u1ea0\0\u1ed1\0\u1f02"+
    "\0\u1f33\0\u1f64\0\u1f95\0\u1fc6\0\u1ff7\0\u2028\0\u2059\0\u208a"+
    "\0\u20bb\0\u20ec\0\u211d\0\u214e\0\u217f\0\223\0\223\0\u217f"+
    "\0\u21b0\0\u21e1\0\u2212\0\u2243\0\u2274\0\u22a5\0\u22d6\0\u2307"+
    "\0\u2338\0\u2369\0\u239a\0\u23cb\0\u23fc\0\u242d\0\u245e\0\u248f"+
    "\0\u24c0\0\u24f1\0\u2522\0\u2553\0\u2584\0\u25b5\0\u25e6\0\u2617"+
    "\0\u2648\0\u2679\0\u26aa\0\u26db\0\u270c\0\u273d\0\u276e\0\u279f"+
    "\0\u27d0";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[217];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\34\4\1\5\24\4\34\6\1\7\24\6\34\10\1\11"+
    "\24\10\103\0\1\12\24\0\1\12\16\0\1\13\75\0"+
    "\1\14\24\0\1\14\32\0\1\15\24\0\1\15\34\0"+
    "\1\16\24\0\1\16\32\0\1\17\24\0\1\17\36\0"+
    "\1\20\24\0\1\20\30\0\1\21\24\0\1\21\36\0"+
    "\1\22\24\0\1\22\16\0\1\23\75\0\1\24\24\0"+
    "\1\24\16\0\1\25\62\0\1\26\1\27\1\30\4\27"+
    "\1\31\1\27\1\32\3\27\1\33\1\27\1\34\3\27"+
    "\2\0\1\27\1\35\1\0\1\36\3\0\1\37\1\0"+
    "\1\40\3\0\1\41\1\0\1\42\14\0\1\43\1\0"+
    "\1\44\4\0\1\45\1\0\1\46\3\0\1\47\1\0"+
    "\1\50\6\0\1\43\1\0\1\44\3\0\1\45\1\0"+
    "\1\46\3\0\1\47\1\0\1\50\12\0\1\51\1\0"+
    "\13\27\1\52\2\27\1\53\4\27\2\0\1\27\12\0"+
    "\1\54\2\0\1\55\13\0\1\51\1\0\23\27\2\0"+
    "\1\27\31\0\1\51\1\0\14\27\1\56\6\27\2\0"+
    "\1\27\13\0\1\57\15\0\1\51\1\0\20\27\1\60"+
    "\2\27\2\0\1\27\17\0\1\61\11\0\1\51\1\0"+
    "\4\27\1\62\16\27\2\0\1\27\3\0\1\63\25\0"+
    "\1\51\1\0\1\64\13\27\1\65\6\27\2\0\1\27"+
    "\1\66\12\0\1\67\15\0\1\51\1\0\4\27\1\70"+
    "\16\27\2\0\1\27\3\0\1\71\42\0\1\54\2\0"+
    "\1\55\21\0\1\54\2\0\1\55\31\0\1\57\24\0"+
    "\1\57\37\0\1\61\24\0\1\61\17\0\1\63\24\0"+
    "\1\63\27\0\1\66\13\0\1\67\11\0\1\66\12\0"+
    "\1\67\23\0\1\71\24\0\1\71\42\0\1\72\2\0"+
    "\1\73\21\0\1\72\2\0\1\73\31\0\1\74\24\0"+
    "\1\74\37\0\1\75\24\0\1\75\17\0\1\76\24\0"+
    "\1\76\27\0\1\77\13\0\1\100\11\0\1\77\12\0"+
    "\1\100\23\0\1\101\13\0\1\102\10\0\1\101\13\0"+
    "\1\102\2\0\2\51\2\0\3\51\1\103\24\51\2\0"+
    "\23\51\7\0\1\51\1\0\13\27\1\104\7\27\2\0"+
    "\1\27\12\0\1\105\16\0\1\51\1\0\20\27\1\106"+
    "\2\27\2\0\1\27\17\0\1\107\26\0\1\105\24\0"+
    "\1\105\40\0\1\107\24\0\1\107\11\0\1\51\1\0"+
    "\12\27\1\110\10\27\2\0\1\27\11\0\1\111\33\0"+
    "\1\111\24\0\1\111\17\0\1\51\1\0\4\27\1\112"+
    "\16\27\2\0\1\27\3\0\1\113\33\0\1\113\24\0"+
    "\1\113\25\0\1\51\1\0\20\27\1\114\2\27\2\0"+
    "\1\27\17\0\1\115\33\0\1\115\24\0\1\115\11\0"+
    "\1\51\1\0\16\27\1\116\4\27\2\0\1\27\15\0"+
    "\1\117\13\0\1\51\1\0\7\27\1\120\13\27\2\0"+
    "\1\27\6\0\1\121\42\0\1\117\24\0\1\117\24\0"+
    "\1\121\24\0\1\121\22\0\1\51\1\0\13\27\1\122"+
    "\7\27\2\0\1\27\12\0\1\123\33\0\1\123\24\0"+
    "\1\123\33\0\1\124\24\0\1\124\40\0\1\125\24\0"+
    "\1\125\25\0\1\126\24\0\1\126\25\0\1\127\24\0"+
    "\1\127\47\0\1\130\24\0\1\130\31\0\1\131\24\0"+
    "\1\131\24\0\1\132\24\0\1\132\37\0\1\133\24\0"+
    "\1\133\35\0\1\134\24\0\1\134\13\0\1\135\61\0"+
    "\1\51\1\0\4\27\1\136\16\27\2\0\1\27\3\0"+
    "\1\137\33\0\1\137\24\0\1\137\25\0\1\51\1\0"+
    "\7\27\1\140\13\27\2\0\1\27\6\0\1\141\33\0"+
    "\1\141\24\0\1\141\22\0\1\51\1\0\12\27\1\142"+
    "\10\27\2\0\1\27\11\0\1\143\33\0\1\143\24\0"+
    "\1\143\17\0\1\51\1\0\12\27\1\144\10\27\2\0"+
    "\1\27\11\0\1\145\33\0\1\145\24\0\1\145\17\0"+
    "\1\51\1\0\20\27\1\146\2\27\2\0\1\27\17\0"+
    "\1\147\33\0\1\147\24\0\1\147\11\0\1\51\1\0"+
    "\1\150\17\27\1\151\2\27\2\0\1\27\1\152\16\0"+
    "\1\153\13\0\1\152\17\0\1\153\5\0\1\152\16\0"+
    "\1\153\11\0\1\51\1\0\13\27\1\154\7\27\2\0"+
    "\1\27\12\0\1\155\33\0\1\155\24\0\1\155\16\0"+
    "\1\51\1\0\20\27\1\156\2\27\2\0\1\27\17\0"+
    "\1\157\33\0\1\157\24\0\1\157\17\0\1\160\24\0"+
    "\1\160\36\0\1\161\24\0\1\161\36\0\1\162\24\0"+
    "\1\162\33\0\1\163\24\0\1\163\41\0\1\164\24\0"+
    "\1\164\13\0\1\165\17\0\1\166\5\0\1\165\16\0"+
    "\1\166\26\0\1\167\24\0\1\167\40\0\1\170\24\0"+
    "\1\170\34\0\1\171\24\0\1\171\7\0\1\135\26\0"+
    "\1\172\32\0\1\51\1\0\22\27\1\144\2\0\1\27"+
    "\21\0\1\145\33\0\1\145\24\0\1\145\7\0\1\51"+
    "\1\0\2\27\1\173\20\27\2\0\1\27\2\0\1\174"+
    "\32\0\1\174\25\0\1\174\26\0\1\51\1\0\1\144"+
    "\22\27\2\0\1\27\1\145\32\0\1\145\25\0\1\145"+
    "\30\0\1\175\1\0\23\27\2\0\1\27\31\0\1\176"+
    "\60\0\1\51\1\0\4\27\1\177\16\27\2\0\1\27"+
    "\3\0\1\200\33\0\1\200\24\0\1\200\25\0\1\51"+
    "\1\0\5\27\1\201\15\27\2\0\1\27\4\0\1\202"+
    "\24\0\1\51\1\0\4\27\1\144\16\27\2\0\1\27"+
    "\3\0\1\145\34\0\1\202\24\0\1\202\32\0\1\145"+
    "\24\0\1\145\25\0\1\51\1\0\20\27\1\144\2\27"+
    "\2\0\1\27\17\0\1\145\33\0\1\145\24\0\1\145"+
    "\11\0\1\51\1\0\4\27\1\203\16\27\2\0\1\27"+
    "\3\0\1\204\33\0\1\204\24\0\1\204\51\0\1\163"+
    "\24\0\1\163\13\0\1\205\25\0\1\205\30\0\1\163"+
    "\25\0\1\163\30\0\1\206\66\0\1\207\24\0\1\207"+
    "\34\0\1\210\24\0\1\210\32\0\1\163\24\0\1\163"+
    "\47\0\1\163\24\0\1\163\17\0\1\211\24\0\1\211"+
    "\25\0\1\212\60\0\1\51\1\0\11\27\1\151\11\27"+
    "\2\0\1\27\10\0\1\153\33\0\1\153\24\0\1\153"+
    "\11\0\2\175\2\0\3\175\1\213\24\175\2\0\23\175"+
    "\2\176\2\0\3\176\1\214\24\176\2\0\23\176\7\0"+
    "\1\51\1\0\16\27\1\144\4\27\2\0\1\27\15\0"+
    "\1\145\33\0\1\145\24\0\1\145\13\0\1\51\1\0"+
    "\16\27\1\215\4\27\2\0\1\27\15\0\1\216\33\0"+
    "\1\216\24\0\1\216\13\0\1\51\1\0\13\27\1\217"+
    "\7\27\2\0\1\27\12\0\1\220\33\0\1\220\24\0"+
    "\1\220\31\0\1\166\24\0\1\166\11\0\2\206\2\0"+
    "\3\206\1\221\24\206\2\0\23\206\27\0\1\163\24\0"+
    "\1\163\33\0\1\222\24\0\1\222\30\0\1\223\24\0"+
    "\1\223\7\0\2\212\2\0\3\212\1\224\24\212\2\0"+
    "\23\212\6\0\1\225\60\0\1\226\61\0\1\51\1\0"+
    "\1\227\22\27\2\0\1\27\1\230\32\0\1\230\25\0"+
    "\1\230\30\0\1\51\1\0\2\27\1\151\20\27\2\0"+
    "\1\27\2\0\1\153\32\0\1\153\25\0\1\153\25\0"+
    "\1\231\63\0\1\232\25\0\1\232\34\0\1\166\25\0"+
    "\1\166\25\0\1\233\60\0\1\225\26\0\1\234\31\0"+
    "\1\226\26\0\1\235\32\0\1\51\1\0\15\27\1\236"+
    "\5\27\2\0\1\27\14\0\1\237\33\0\1\237\24\0"+
    "\1\237\13\0\1\231\26\0\1\240\51\0\1\241\24\0"+
    "\1\241\13\0\1\233\26\0\1\242\23\0\34\243\1\0"+
    "\24\243\7\0\1\51\1\0\6\27\1\144\14\27\2\0"+
    "\1\27\5\0\1\145\33\0\1\145\24\0\1\145\14\0"+
    "\34\244\1\0\24\244\17\0\1\163\24\0\1\163\14\0"+
    "\34\245\1\0\24\245\34\243\1\246\24\243\34\244\1\247"+
    "\24\244\34\245\1\250\24\245\5\0\1\251\60\0\1\252"+
    "\60\0\1\253\75\0\1\254\24\0\1\254\33\0\1\255"+
    "\24\0\1\255\33\0\1\256\24\0\1\256\32\0\1\257"+
    "\24\0\1\257\33\0\1\260\24\0\1\260\33\0\1\261"+
    "\24\0\1\261\36\0\1\262\24\0\1\262\33\0\1\263"+
    "\24\0\1\263\33\0\1\264\24\0\1\264\44\0\1\265"+
    "\60\0\1\266\60\0\1\267\24\0\2\270\1\0\1\271"+
    "\27\0\1\272\1\0\1\270\46\0\1\273\24\0\1\273"+
    "\31\0\1\274\24\0\1\274\23\0\1\275\25\0\1\275"+
    "\41\0\1\276\24\0\1\276\42\0\1\277\24\0\1\277"+
    "\27\0\1\300\24\0\1\300\35\0\1\301\24\0\1\301"+
    "\14\0\1\302\61\0\1\270\61\0\1\35\1\0\1\36"+
    "\4\0\1\37\1\0\1\40\1\303\2\0\1\41\1\0"+
    "\1\304\6\0\1\35\1\0\1\36\3\0\1\37\1\0"+
    "\1\40\1\303\2\0\1\41\1\0\1\304\23\0\1\305"+
    "\24\0\1\305\30\0\1\71\13\0\1\306\10\0\1\71"+
    "\13\0\1\306\32\0\1\307\24\0\1\307\31\0\1\310"+
    "\24\0\1\310\20\0\1\311\25\0\1\311\51\0\1\312"+
    "\24\0\1\312\10\0\1\313\60\0\1\314\101\0\1\315"+
    "\24\0\1\315\3\0\2\314\2\0\3\314\1\316\24\314"+
    "\2\0\23\314\11\0\1\317\25\0\1\317\27\0\1\320"+
    "\75\0\1\321\24\0\1\321\16\0\1\320\26\0\1\322"+
    "\40\0\1\323\24\0\1\323\16\0\34\324\1\0\24\324"+
    "\7\0\1\316\51\0\34\324\1\325\24\324\5\0\1\326"+
    "\75\0\1\327\24\0\1\327\32\0\1\330\24\0\1\330"+
    "\36\0\1\331\24\0\1\331\44\0\1\270\23\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[10241];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\1\11\1\1\1\11\1\1\1\11\1\1\12\0"+
    "\1\11\145\0\1\11\41\0\1\1\30\0\1\1\2\11"+
    "\42\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[217];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S200_Partitions() { }
	
	private ArrayList<Object> partitionsAndText = new ArrayList<Object>();

	private AnnotationEntity firstEntity = null;
	private boolean modeSet = false;
	private boolean ascendingMode = false;
	
	private StringBuilder buffer = new StringBuilder();


	private void propagateBackwards(AnnotationEntity retrievedEntity) {
	
		for(Object partext : partitionsAndText) {
			
			if( !(partext instanceof Partition)) continue;
			
			if(partext == annotationEntity) continue; // avoid checking the actual partition
	
			if(((Partition) partext).getRank() < ((PartitionElement) retrievedEntity).getRank()) {
			
				((Partition) partext).addRelatedEntity(retrievedEntity);
				retrievedEntity.addRelatedEntity((Partition) partext);
				
				((Partition) partext).updateValue();
			}
		}
	}
	
	private void propagateForward(AnnotationEntity retrievedEntity) {
	
		for(Object partext : partitionsAndText) {
			
			if( !(partext instanceof Partition)) continue;
			
			if(partext == annotationEntity) continue; // avoid checking the actual partition
			
			for(AnnotationEntity related : ((Partition) partext).getRelatedEntities()) {
			
				if( !(related instanceof PartitionElement)) continue;
				
				if(((PartitionElement) related).getRank() > ((PartitionElement) retrievedEntity).getRank()) {

					annotationEntity.addRelatedEntity(related);
					related.addRelatedEntity(annotationEntity);
					
					((Partition) annotationEntity).updateValue();
				} 
			}	
		}
	}
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S200_Partitions(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 9: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 10: break;
          case 3:
            { offset++;
		position++;
		
		if(offset >= length) {
			
			if(offset > length) {
				yypushback(1);
				position--;
			}
			
			for(Object partext : partitionsAndText) {
				
				if(partext instanceof String) {
				
					addText((String) partext);
				}
				
				if(partext instanceof AnnotationEntity) {
				
					addEntity((AnnotationEntity) partext);
				}
			}
			
			yybegin(0);
		}
		
		buffer.append(yytext());
            }
          // fall through
          case 11: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 12: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 13: break;
          case 6:
            { //System.out.println("PARTITIONS PATTERN: " + yytext());

	partitionsAndText = new ArrayList<Object>();
	
	firstEntity = null;
	
	modeSet = false;
	buffer = new StringBuilder();

	offset = 0;
	length = yylength();	
	
	yypushback(length);
	
	/*
	annotationEntity = new Partition();
	annotationEntity.setPosition(position);
	partitionsAndText.add(annotationEntity);
	*/
	annotationEntity = null;
	
	yybegin(readPartitionState);
            }
          // fall through
          case 14: break;
          case 7:
            { AnnotationEntity retrievedEntity = retrieveEntity();
		
		//System.out.println("PART_ELEMENT: " + yytext());
		
		if(firstEntity == null) {
		
			firstEntity = retrievedEntity;
	
		} else {
		
			if( !modeSet) {
			
				if(((PartitionElement) retrievedEntity).getRank() > ((PartitionElement) firstEntity).getRank()) {
				
					//System.out.println("ASCENDING MODE");
					
					ascendingMode = true;
					modeSet = true;
				}
				
				if(((PartitionElement) retrievedEntity).getRank() < ((PartitionElement) firstEntity).getRank()) {
					
					//System.out.println("DESCENDING MODE");
				
					ascendingMode = false;
					modeSet = true;
				}
			}
		}
	
		//UPDATE 3.3.1 VERIFICA IL RANKING E IL MODE PER INIZIALIZZARE UNA NUOVA PARTITION O AGGIUNGERE ALL'ATTUALE
		
		boolean addPartition = false;
		
		if(modeSet && ascendingMode && ((Partition) annotationEntity).getRank() < ((PartitionElement) retrievedEntity).getRank()) {
		
			addPartition = true;
		}
		
		if(modeSet && !ascendingMode && ((Partition) annotationEntity).getMinRank() > ((PartitionElement) retrievedEntity).getRank()) {
		
			addPartition = true;
		}
		
		/* 
		Update 3.3.8 -- ATTENZIONE - CASO IBRIDO !
		
		Gestione casi ibridi, ovvero che iniziano come descending ma hanno l'articolo in fondo a comune, es.:
		"costituzionale del commi 10 lett. a) e 11 dell'art. 23-bis del decreto-legge n. 112 del 2008, nel testo"
		
		*/
		if(modeSet && !ascendingMode && ((PartitionElement) retrievedEntity).getRank() == 8 && ((Partition) annotationEntity).getMaxRank() < 8) {
			
			//Occorre aggiungere l'articolo all'ultima partizione e propagarlo ad eventuali partition precedenti
			
			addPartition = true;
			
			propagateBackwards(retrievedEntity);
		}
		
		if(addPartition) {
			
			//AGGIUNGI
		
			annotationEntity.setText(Util.removeAllAnnotations(annotationEntity.getText() + buffer.toString() + retrievedEntity.getText()));
			buffer = new StringBuilder();
			 
			annotationEntity.addRelatedEntity(retrievedEntity);
			retrievedEntity.addRelatedEntity(annotationEntity);
			
			((Partition) annotationEntity).updateValue();
			
			if(modeSet) {
				
				if(ascendingMode) {
					
					propagateBackwards(retrievedEntity);			
				}
			}
			
		} else {
		
			//INIZIALIZZA NUOVA PARTITION
			
			annotationEntity = new Partition();
			annotationEntity.setPosition(position);

			if(buffer.length() > 0) {
			
				partitionsAndText.add(buffer.toString());
				buffer = new StringBuilder();
			}
			
			partitionsAndText.add(annotationEntity);
			
			annotationEntity.addRelatedEntity(retrievedEntity);
			retrievedEntity.addRelatedEntity(annotationEntity);
			
			annotationEntity.setText(retrievedEntity.getText());
			
			((Partition) annotationEntity).updateValue();
			
			if(modeSet) {
				
				if(ascendingMode) {
	
					//Aggiungi questo elemento alle partizioni precedenti che non avevano questo elemento o elementi di ordine superiore SE SIAMO IN UP

					propagateBackwards(retrievedEntity);
	
				} else {
				
					//Si ereditano gli oggetti di ordine superiore delle partizioni precedenti SE SIAMO IN DOWN
					
					propagateForward(retrievedEntity);				
				}
			}				
		}
		
		position += Util.removeAllAnnotations(yytext()).length();
		offset += yylength();
            }
          // fall through
          case 15: break;
          case 8:
            { AnnotationEntity retrievedEntity = retrieveEntity();
		
		if(yytext().indexOf(":AND:") > -1) {
			
			//è un LKN_AND
		
			if( !modeSet) firstEntity = null;
		}
		
		offset += yylength();

		if(offset > length) {
		
			yypushback(yylength());

			for(Object partext : partitionsAndText) {
				
				if(partext instanceof String) {
				
					addText((String) partext);
				}
				
				if(partext instanceof AnnotationEntity) {
				
					addEntity((AnnotationEntity) partext);
				}
			}

			yybegin(0);
		
		} else {

			position += retrievedEntity.getText().length();
			//buffer.append(retrievedEntity.getText());
			buffer.append(yytext());
		}
            }
          // fall through
          case 16: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S200_Partitions [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S200_Partitions scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S200_Partitions(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
